package necessary;

import com.google.protobuf.ByteString;
import meerkat.protobuf.ConcreteCrypto;
import meerkat.protobuf.Crypto;
import meerkat.protobuf.Mixing;
import qilin.primitives.RandomOracle;
import java.math.BigInteger;

/**
 * Created by Tzlil on 12/14/2015.
 */
public class GeneralImpl implements General {


    private final RandomOracle rndomOracle;
    private final ByteString h;
    private final ByteString g;

    public GeneralImpl(RandomOracle randomOracle,ByteString g,ByteString h) {
        this.rndomOracle = randomOracle;
        this.h = h;
        this.g = g;
    }

    @Override
    public ConcreteCrypto.ElGamalCiphertext calcRerandomizable2ElGamal(Crypto.RerandomizableEncryptedMessage enc) {
        return null;
    }

    @Override
    public ByteString getG() {
        return g;
    }

    @Override
    public ByteString getH() {
        return h;
    }

    @Override
    public BigInteger hash(Mixing.ZeroKnowledgeProof.OrProof.ForRandomOracle input) {
        byte[] arr = input.toByteArray();
        return new BigInteger(this.rndomOracle.hash(arr,arr.length));
    }
}
